<script>
	import { onMount } from "svelte";
    // import Select from "svelte-select";
    import Svelecte from 'svelecte';
	import Hidden from './Hidden.svelte';
	import { getdhaatuLables, fetchList } from "../service/common";
	import {apiData, KrdantaList} from "../service/format";
	import { Accordion, AccordionItem,  Card, Col, Container, Row,
    CardBody,
    CardFooter,
    CardHeader,
    CardSubtitle,
    CardText,
    CardTitle,
	Button,
	Form, FormGroup, FormText, Input, Label, Spinner, Alert   } from 'sveltestrap';
	import { JsonView } from '@zerodevx/svelte-json-view';
	let inputSelected = 'DEVANAGARI';
	let outputSelected = 'DEVANAGARI';
	let dhaatuTags = '';
	let dhaatu = '';
	let pratyayas = '';
	let scriptOptions = ['DEVANAGARI', 'SLP1'];
    // dhatuLables must be [''] or alike and not []
	let dhatuLables = ['...'];
	let pratyayasLables = [];
	let ganas = [];
	let anta = [];
	let upada = [];
	let ganasSelected = '';
	let antaSelected = '';
	let upadaSelected = '';
	let spinnerShow = false;
	let expected = '';
	let generated = '';
	let alert = false;
	apiData.set([]);
	async function getdhaatuLablesCall () {
		 dhatuLables = await getdhaatuLables('dhatu_labels',outputSelected);
		 pratyayasLables = await getdhaatuLables('pratyayas',outputSelected);
		 ganas = await getdhaatuLables('dhatu_ganas',outputSelected);
		 anta = await getdhaatuLables('dhatu_anta',outputSelected);
		 upada = await getdhaatuLables('dhatu_upadha',outputSelected);
		//console.log('dhatuLables',dhatuLables)
	};

    function clearResult() {
        apiData.set([]);
        generated = '';
        expected = '';
    }

	async function submit() {
		spinnerShow=true;
		let dataValue = await fetchList(dhaatu["label"], pratyayas, outputSelected, outputSelected);
		spinnerShow=false;
        console.log('Expected = ', + dataValue.expected);
		if(dataValue.generated) {
            if (dataValue.expected.length > 0) {
                expected = dataValue.expected.join(' / ');
            }
            else {
                expected = 'Not available.';
            }
			generated = dataValue.generated;
           //apiData.set([]); //this does not update the UI. However, a button click that calls the function clearResult does the job. 
			apiData.set(dataValue.mods);
            console.log("dataValue.mods = ", dataValue.mods);
			alert = false;
		} else {
			alert = true;
			expected = '';
			generated = '';
			apiData.set([]);
		}
		
	}

	async function gettagsCall() {
		let param =[];
		if(ganasSelected!='') {
			param.push('gaRa:'+ganasSelected);
		}
		if(antaSelected!='') {
			param.push('x_anta:'+antaSelected);
		}
		if(upadaSelected!='') {
			param.push('x_upadhA:'+upadaSelected);
		}
		console.log('param',param)
		if(param.length<=0){
			dhatuLables = await getdhaatuLables('dhatu_labels',outputSelected);
		} else {
			
			dhatuLables = await getdhaatuLables('',outputSelected,param.join(','));
		}
		
	}
	onMount(async () => {
		getdhaatuLablesCall();

	})
	function hideOrshow(id) {
		var x = document.getElementById(id);
		x.classList.toggle('hide');
		// If selected element is hidden
	
	}
	const json = [{ foo: 'bar' }]
</script>

<container class="d-flex flex-column p-2 kradanta">
	<!-- <Row>
    	<Col> <h4 class="alert-heading text-capitalize">Generate Krdanta Forms</h4>​</Col>
  	</Row> -->
	<Row>
		<Col class="col-sm-9">
			<Card >
				<CardHeader>
					<CardTitle>Generate Krdanta Forms</CardTitle>
				</CardHeader>
				<CardBody class="minHeight">
					<div class="mx-auto  rounded">
						<div>
							<div class="row">
								<div class="col-sm-4">
									<div class="form-group">
                                   <!-- 
										<select class="form-select selectpicker" bind:value={dhaatu}>
											<option value=''>Select Dhaatu</option>
											{#each dhatuLables as value}
												<option>{value}</option>
											{/each}
										</select>
                                    -->
                                    
                                        <Svelecte options={dhatuLables} 
                                            inputId="dhaatuSelect"
                                            bind:readSelection={dhaatu}
                                                placeholder="Select Dhaatu"
                                                ></Svelecte>
                                     
                                     <!--
                                     <p>{filteredDhaatu}</p>
                                     <Select {dhaatu} bind:filteredDhaatu />
                                    -->
									</div>
								</div>
								<div class="col-sm-4">
									<div class="form-group">
										<select class="form-select" bind:value={pratyayas}>
											<option value=''>Select Pratyaya</option>
											{#each pratyayasLables as value}
												<option>{value}</option>
											{/each}
										</select>
									</div>
								</div>
								<div class="col-sm-3">
									<div class="form-group d-flex m-auto">
										<button type="button" class="btn btn-primary" style="margin-right: 5px;" on:click={submit}>Search</button>
										<button type="button" class="btn btn-secondary" style="margin-right: 5px;" on:click={clearResult}>Clear</button>
										{#if spinnerShow}
											<Spinner primary/>
										{/if}
									</div>
								</div>
							</div>
							
						</div>
						{#if alert}
						<div class="alert alert-danger mt-5" role="alert">
							<h4 class="alert-heading text-capitalize">No records found</h4>
							Please try with different search
							.
						</div>
						{/if}
						{#if generated || expected}
						<div class="mt-5">
							<div>
								<div class="row">
									<dd class="col-sm-6">
										
									<div class="row">
										<dt class="col-sm-3">Generated:</dt>  <dd class="col-sm-9">{generated}</dd>
									</div>
								</dd>
								<dd class="col-sm-6">
									<div class="row">
										<dt class="col-sm-3">Expected:</dt> <dd class="col-sm-9">{expected}</dd>
									</div>
								
								</dd>
								</div>
							</div>	
						</div>
						{/if}
						{#if $KrdantaList.length>=1}
						<div>
							<div class="row">
								
									<dt class="col-sm-3">	Generation Process</dt>
							
							</div>
							<div>
								<table class="table table-striped">
									<thead class="thead-dark">
									  <tr>
										<th scope="col">Sutra Id</th>
										<th scope="col">Sutra text</th>
										<th scope="col">New Sabdas</th>
										<th scope="col">Output form</th>
<!--										<th scope="col">Varnas</th>
-->
									  </tr>
									</thead>
									<tbody id="KrBody">
									{#each $KrdantaList as item}	
									  <tr on:click={hideOrshow(item.seqno)}>
										<td>{item.sutra_id}</td>
										<td>{item.sutra_text}</td>
										<td>{item.out_padas}</td>
										<td>{item.out_form}</td>
										<!-- <td>{item.text3}</td> -->
									  </tr>
									
									  <!--<tr id="{item.seqno}" class="hide"> -->
									  <tr id="{item.seqno}">
										  <td colspan="4">
											<Hidden data="{item}"></Hidden>
										  </td>
									  </tr>
									{/each}  
									</tbody>
								  </table>
							</div>
						</div>
						{/if}
					</div>
				</CardBody>
			</Card>
			
			
		</Col>
		<Col class="col-sm-16">
		<Card >
			<CardHeader>
				<CardTitle>Filter</CardTitle>
			</CardHeader>
			<CardBody>
				<CardSubtitle>Preferences</CardSubtitle>
				<CardText class="mt-2">
					<Accordion stayOpen>
						<AccordionItem active header="script">
							<select class="form-select selectpicker" bind:value={outputSelected} on:change={getdhaatuLablesCall}>
							
							{#each scriptOptions as value}
								<option value={value}  > {value}</option>
							{/each}
							</select>
						</AccordionItem>
						<AccordionItem active header="Select Dhatus​">
						
							<select class="form-select selectpicker" bind:value={antaSelected} on:change={gettagsCall}>
								<option value="">Select anta</option>
							{#each anta as value}
								<option value={value}  > {value}</option>
							{/each}
							</select><br/>
							<select class="form-select selectpicker" bind:value={ganasSelected} on:change={gettagsCall}>
								<option value="">Select ganas</option>
							{#each ganas as value}
								<option value={value}  > {value}</option>
							{/each}
							</select><br/>
							<select class="form-select selectpicker" bind:value={upadaSelected} on:change={gettagsCall}>
								<option value="">Select upadha</option>
							{#each upada as value}
								<option value={value}  > {value}</option>
							{/each}
							</select>
						</AccordionItem>
					</Accordion>
				</CardText>
			</CardBody>
		</Card>
		</Col>
	</Row>
</container>
<style>
	/* main {
		text-align: center;
		padding: 1em;
		max-width: 240px;
		margin: 0 auto;
	}

	h1 {
		color: #ff3e00;
		text-transform: uppercase;
		font-size: 4em;
		font-weight: 100;
	}

	@media (min-width: 640px) {
		main {
			max-width: none;
		}
	}
	 */
	 .hide {
		 display: none;
	 }
</style>
